<template>
	<section class="wishlist-intake-status">
		<cdx-field :disabled="disabled">
			<cdx-select
				v-model:selected="statusValue"
				:menu-items="statusOptions"
				@update:selected="$emit( 'update:status', $event )"
			></cdx-select>
			<template #label>
				Status
			</template>
			<template #description>
				Only staff can change the status of a wish.
			</template>
		</cdx-field>
	</section>
</template>

<script>
import { defineComponent } from 'vue';
import { CdxField, CdxSelect } from '@wikimedia/codex';
import Wish from '../common/Wish.js';

export default defineComponent( {
	name: 'StatusSection',
	components: {
		CdxField,
		CdxSelect
	},
	props: {
		status: { type: String, default: Wish.STATUS_SUBMITTED },
		disabled: { type: Boolean, default: false }
	},
	emits: [
		'update:status'
	],
	data( props ) {
		return {
			statusValue: props.status,
			statusOptions: [
				{ label: mw.msg( 'communityrequests-status-draft' ), value: Wish.STATUS_DRAFT },
				{ label: mw.msg( 'communityrequests-status-submitted' ), value: Wish.STATUS_SUBMITTED },
				{ label: mw.msg( 'communityrequests-status-open' ), value: Wish.STATUS_OPEN },
				{ label: mw.msg( 'communityrequests-status-in-progress' ), value: Wish.STATUS_IN_PROGRESS },
				{ label: mw.msg( 'communityrequests-status-delivered' ), value: Wish.STATUS_DELIVERED },
				{ label: mw.msg( 'communityrequests-status-blocked' ), value: Wish.STATUS_BLOCKED },
				{ label: mw.msg( 'communityrequests-status-archived' ), value: Wish.STATUS_ARCHIVED }
			]
		};
	}
} );
</script>
